c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine divide_ParallelPrep(i_filterTest)

      include 'common.3D'
   
c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'In step_predictor_corrector.f BEFORE SendRecv_Data.f'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp    ',up(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*,'pVol(i) ',pVol(i)
c        print*,'nb_local ',nb_local
c        print*,'np_local ',np_local
c        print*,'nbf_image_local       = ',nbf_image_local
c        print*,'nbfm_image_local = ',nbfm_image_local
c        print*,'nbfreem_image_local     = ',nbfreem_image_local
c        print*,'nb_image_local ',nb_image_local
c        print*,'np_image_local ',np_image_local
c        print*,'np_start ',np_local+ 1 + (nb_image_local - nb_local)
c        print*
c      end if
c      !-------------------
!       itime_check2 = 122
!       if(rank_id.eq.0.and.itime.eq.itime_check2)then
!         print*,'dPP, Pt 1a: itime, xmax_container ',itime,xmax_container
!       endif      
      if(n_procs.gt.1.or.iCartTop_periodicity(1))then
       call identify_Ps_for_Exporting_toWest
       if(i_call_UpDown.eq.1)    call identify_Ps_for_Exporting_toBelow
       if(i_call_NorthSouth.eq.1)call identify_Ps_for_Exporting_toSouth  !3-D only
       call SendRecv_Data_toWest
       if(i_call_UpDown.eq.1)then
         call SendRecv_Data_toBelow
       else
         kk_highest_after_SR_toBelow = kk_highest_after_SR_toWest
       endif
       if(i_call_NorthSouth.eq.1)call SendRecv_Data_toSouth  !3-D only
      
c      --- Secondary Divide for Guest Particles ---
       np_start = np_local+ 1 + (nb_image_local - nb_local)
       i_resident_0 = 2  !Guest Particles
       if(iopt_movingObject.eq.1)then
c        call divide(nbp1_local, nb_image_local, 1, i_resident_0,
c     &                                rank_id, n_procs, ierr)
        nbf_guests       = nbf_image_local       - nbf_local
        nbfm_guests      = nbfm_image_local - nbfm_local
     &                   - nbf_guests
        nbfreem_guests     = nbfreem_image_local - nbfreem_local
     &                   - nbf_guests - nbfm_guests
        nbf_start       = nbf_local
        nbfm_start      = nbfm_image_local - nbfm_guests
        nbfreem_start   = nbfreem_image_local     - nbfreem_guests

        call divide(nbf_start + 1  , nbf_image_local   ,1,i_resident_0)  !- Fixed boundary particles -        
        call divide(nbfm_start+1   ,nbfm_image_local   ,1,i_resident_0)  !- Forced-motion boundary particles -        
        call divide(nbfreem_start+1,nbfreem_image_local,1,i_resident_0)  !- Free-motion boundary particles -
       else
        call divide(nbp1_local, nb_image_local, 1, i_resident_0)
       end if
       call divide(np_start    , np_image_local, 2, i_resident_0)

      endif    !End of:   if(n_procs.gt.1)then

      if(i_densityFilter.gt.0.and.i_filterTest.gt.0.and.
     &   itime/ndt_FilterPerform*ndt_FilterPerform.eq.itime)then 
         call densityFilter
      endif

      return
      end
